#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "reduce_connection4xi.py">
#<abstract4xi abstract = "providing function reduce_connection4xi"/>
#<refer4xi reference = "reduction.py"/>
#<state4xi status = "[ACK4tagging] [ACK4OS2ALL] [NACK4moduletesting] [NACK4systemtesting] [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'reduce_connection4xi' ]
#" 
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
    import socket
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import traceback         
except:
    pass

#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.reduction import reduce_connection
except:
    print("reduce_connection4xi.py: *** failed in from multiprocessing.reduction import reduce_connection ***")
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from _get_listener4xi import _get_listener4xi

from dupfd4xi import DupFd4Xi

from reduce_handle4xi import reduce_handle4xi
from rebuild_connection4xi import rebuild_connection4xi

from print4xi import print4xi
from time4xi import time4xi
#"
#/>
 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "reduce-connection4xi" usage = "
#   returns rebuilt connection  
#"> 
#<state4xi status = "[ACK4tagging] [ACK4OS2ALL] [NACK4moduletesting] [NACK4systemtesting] [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
def reduce_connection4xi(conn):
    '''
    reduce_connection4xi returns rebuilt connection 
    '''
    class2print = "reduce_connection4xi"
    method2print = "reduce_connection4xi"
    
    if sys.platform == 'win32':
                
        # -----------------------------------------------------------------------------------------    
        # (Step 0/2) - Windows
        # -----------------------------------------------------------------------------------------    
        message2print = "{(Step 0/2a) started" + "; reduce-connection4xi-started: " + str(reduce_connection4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
            
        message2print = "{(Step 0/2a) passed" + "; conn-passed-to-reduce-connection4xi: " + str(conn) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                      
                
        # -----------------------------------------------------------------------------------------    
        # (Step 1/2) - Windows
        # -----------------------------------------------------------------------------------------        
        fileno2xi = conn.fileno()
        message2print = "{(Step 1/2a) set" + "; fileno2xi-set-by-reduce-connection4xi to: " + str(fileno2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{(Step 1/2b) passing" + "; fileno2xi-passing-to-reduce-handle4xi-by-reduce-connection4xi: " + str(fileno2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
            
        handle2xi = reduce_handle4xi(fileno2xi)
        
        message2print = "{(Step 1/2c) set" + "; handle2xi-set-by-reduce-connection4xi to: " + str(handle2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
              
        # -----------------------------------------------------------------------------------------    
        # (Step 2/2) - Windows
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 2/2a) passing" + "; handle2xi-passing-to-socket-fromfd-by-reduce-connection4xi: " + str(handle2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
            
                
        with socket.fromfd(handle2xi, socket.AF_INET, socket.SOCK_STREAM) as s:
     
            message2print = "{(Step 2/2b) passing" + "; s-passing-to-DupSocket4Xi-by-reduce-connection4xi: " + str(s) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
            ds2xi = DupSocket4Xi(s)
            
            message2print = "{(Step 2/2c) set" + "; ds2xi-set-by-reduce-connection4xi to: " + str(ds2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
            message2print = "{(Step 2/2d) returning" + "; reduce-connection4xi-returning: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            
            return rebuild_connection4xi, (ds2xi, conn.readable, conn.writable)
    else:
                
        # -----------------------------------------------------------------------------------------    
        # (Step 0/2) - non-Windows
        # -----------------------------------------------------------------------------------------     
        message2print = "{(Step 0/2a) started" + "; reduce-connection4xi-started: " + str(reduce_connection4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
            
        message2print = "{(Step 0/2b) passed" + "; conn-passed-to-reduce-connection4xi: " + str(conn) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                      
                
        # -----------------------------------------------------------------------------------------    
        # (Step 1/2) - non-Windows
        # -----------------------------------------------------------------------------------------        
        fileno2xi = conn.fileno()
        message2print = "{(Step 1/2a) set" + "; fileno2xi-set-by-reduce-connection4xi to: " + str(fileno2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{(Step 1/2b) passing" + "; fileno2xi-passing-to-DupFd4Xi-by-reduce-connection4xi: " + str(fileno2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
            
        df2xi = DupFd4Xi(fileno2xi)
        
        message2print = "{(Step 1/2c) set" + "; df2xi-set-by-reduce-connection4xi to: " + str(df2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
              
        # -----------------------------------------------------------------------------------------    
        # (Step 2/2) - non-Windows
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 2/2) returning" + "; reduce-connection4xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
            
        return rebuild_connection4xi, (df2xi, conn.readable, conn.writable)    
    #</function4xi>
#</program4xi>
    
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of reduce_connection4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
